/*******************************************************************************
*  PWM(CCP1)RC2s`g𔭐Tv                            *
*                                                                              *
*  FRB0so͂ꍇ́ACCP1SEL=1 ƋLq܂                   *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2018-04-22  ޒH[(ނ)  Create                            *
* ============================================================================ *
*  PIC 16F1786                                                                 *
*  MPLAB X(v4.10)                                                              *
*  MPLAB(R) XC8 C Compiler Version 1.40                                        *
*******************************************************************************/
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define _XTAL_FREQ 32000000        // gpPICɂ蓮glݒ肷

// RtBM[VP̐ݒ
#pragma config FOSC     = INTOSC   // ۯgp(INTOSC)
#pragma config WDTE     = OFF      // ޯϰ(OFF)
#pragma config PWRTE    = ON       // dON64ms۸тJn(ON)
#pragma config MCLRE    = OFF      // OؾĐM͎gp޼ٓ(RE3)݂Ƃ(OFF)
#pragma config CP       = OFF      // ۸ذی삵Ȃ(OFF)
#pragma config CPD      = OFF      // ްذی삵Ȃ(OFF)
#pragma config BOREN    = ON       // dd~(BORVݒȉ)펞Ď@\ON(ON)
#pragma config CLKOUTEN = OFF      // CLKOUT݂RA6݂Ŏgp(OFF)
#pragma config IESO     = OFF      // Oۯւ̐ؑւł̋N͂Ȃ(OFF)
#pragma config FCMEN    = OFF      // OۯĎȂ(OFF)
// RtBM[VQ̐ݒ
#pragma config WRT      = OFF      // Flashذی삵Ȃ(OFF)
#pragma config VCAPEN   = OFF      // VCAPsŎgpȂARA6̓fW^sƂ(OFF)
#pragma config PLLEN    = ON       // 4xPLLANbN32MHzœ\(ON)
#pragma config STVREN   = ON       // X^bNI[ot[A_[t[烊Zbg(ON)
#pragma config BORV     = HI       // dd~펞Ďd(2.7V)ݒ(HI)
#pragma config LPBOR    = OFF      // d̓uEAEgZbg(LPBOR_OFF)
#pragma config LVP      = OFF      // dvO~O@\gpȂ(OFF)

// ֐̃vg^Cv錾
void PWM_Set(void) ;
int  PWM_Frequency(long frequency) ;
void PWM_Start(int duty) ;


/*******************************************************************************
*  C̏                                                                *
*******************************************************************************/
void main()
{
     int d ;

     OSCCON = 0b01110000 ;    // NbN8MHzx4=32MHzƂ
     ANSELA = 0b00000000 ;    // AN0-AN4͎gpȂSăfW^I/OƂ
     ANSELB = 0b00000000 ;    // AN8-AN13͎gpȂSăfW^I/OƂ
     TRISA  = 0b00000000 ;    // RA0-RA7͑Sďo͂ɊĂ
     TRISB  = 0b00000000 ;    // RB0-RB7͑Sďo͂ɊĂ
     TRISC  = 0b00000000 ;    // RC0-RC7͑Sďo͂ɊĂ
     TRISE  = 0b00000000 ;    // RE3(MCLR)͓͐p
     PORTA  = 0b00000000 ;    // RAo̓s̏(SLOWɂ)
     PORTB  = 0b00000000 ;    // RCo̓s̏(SLOWɂ)
     PORTC  = 0b00000000 ;    // RCo̓s̏(SLOWɂ)

     PEIE   = 1 ;             // ӑu荞ݗL
     GIE    = 1 ;             // Ŝ̊ݏ

     PWM_Set() ;              // CCP1PWMݒ
     d = PWM_Frequency(1000) ;// PWMg1KHz
     PWM_Start(d/10) ;        // feB10%

     while(1) {
     }
}
/*******************************************************************************
*  PWM_Set()                                                                   *
*    PWM(CCP1)̐ݒs                                                 *
*******************************************************************************/
void PWM_Set(void)
{
     // ^C}[Q̐ݒ(^C}[TIMER2̂ݎgp\)
     T2CON   = 0b00000010 ;   // TMR2vXP[lPU{ɐݒ
     TMR2    = 0 ;            // ^C}[QJE^[
     // CCP1̐ݒ
     CCP1SEL = 0 ;            // RC2(13)sCCP1o͂Ɋ蓖Ă
     CCP1CON = 0b00001111 ;   // PWM@\gp
     CCPR1L  = 0 ;            // f[eBl͂Oŏ
     CCPR1H  = 0 ;
     PR2     = 0 ;
}
/*******************************************************************************
*  ans = PWM_Frequency(frequency)                                              *
*    PWM(CCP1)̏o͎gݒ肷鏈                                       *
*    ̊֐ĂяoATimer2͒~܂APWM_Start()ŊJn܂傤B *
*    frequency : ݒ肷g(Hz)w(500-2000000Hz)                     *
*    ans       : -1=ݒs\Ȏgł ȊO͖100%̃feBԂ*
*******************************************************************************/
int PWM_Frequency(long frequency)
{
     unsigned int pr , p ;

     TMR2ON = 0 ;   // Timer2̒~
     p = 0 ;
     // PWM̎evXP[lŌvZ255ȉȂ̗p
     pr = (_XTAL_FREQ/(frequency*4*1)) - 1 ;                // P{
     if (pr >= 255) {
          p = 1 ;
          pr = (_XTAL_FREQ/(frequency*4*4)) - 1 ;           // S{
          if (pr >= 255) {
               p = 2 ;
               pr = (_XTAL_FREQ/(frequency*4*16)) - 1 ;     // PU{
               if (pr >= 255) {
                    p = 3 ;
                    pr = (_XTAL_FREQ/(frequency*4*64)) - 1 ;// US{
                    if (pr >= 255) return -1 ;              // ݒs
               }
          }
     }
     PR2  = pr ;              // PWM̎ݒ
     T2CONbits.T2CKPS = p ;   // vXP[l̐ݒ

     return (10 * (4*(pr+1))) / 10 ;
}
/*******************************************************************************
*  PWM_Start(duty)                                                             *
*    PWM(CCP1)̏o͂Jn鏈                                             *
*    duty : PWM̃feBw肷(10bit)                                   *
*           o͎gȂ10bitłȂ6bitƂȂȂčs܂      *
*******************************************************************************/
void PWM_Start(int duty)
{
     CCPR1L = duty & 0x00FF ; // f[eBl10bit(CCP1H/CCP1L)El
     CCPR1H = duty >> 8 ;     // CCP1H=HIGHoCg  CCP1L=LOWoCg 
     TMR2ON  = 1 ;            // TMR2(PWM)X^[g
}
